//+------------------------------------------------------------------+
//|                                                     ARTIOM.mq4   |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Rid"
#property link      "http://www.tradersforum.net.ru/"
//  
//---- input parameters
extern string   _____= "  "; 
extern bool     Long=True;
extern int      MagicBuy = 555555;
extern double          n = 5;//    
extern string   ____= "  ";
extern bool     Short=True;
extern int      MagicSell = 777777;
extern double          n_ = 5;//    
extern string   _= "   ";
extern int          tp = 65;
extern int          sl = 65;
extern bool     UseTrailing  = true;     //  
extern int      MinProfit      = 0;     //    
extern int      TrailingStop   = 70;   //   
extern int      TrailingStep   = 5;   //   
extern double       Lots = 0.1;
int ticket  ;
int ExpertBars;
//--   --
//#include  <b-Lots.mqh>  //MoneyManagement
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()  {  return(0);  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()  {   return(0);  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 if (UseTrailing) TrailPositions(); //   
  
//------------    ----------------------------------------------
/*
bool isNewBar=false;
if (ExpertBars !=Bars) {ExpertBars=Bars; isNewBar=true; } 
if (isNewBar)  {           //    :*/

  for ( int v = OrdersTotal() - 1; v >= 0; v -- )                      { 
    if (OrderSelect(v, SELECT_BY_POS, MODE_TRADES))                      {           
       if (OrderSymbol()==Symbol() 
        &&  (OrderMagicNumber() == MagicBuy)||OrderMagicNumber() == MagicSell)  {      
//---------------------------------------------------------------------------------           
if(OrderProfit() >Lots*10* tp)  { OrderClose(OrderTicket(),OrderLots(),Bid,3,Green); }
if(OrderProfit()<= -sl*Lots*10) { OrderClose(OrderTicket(),OrderLots(),Bid,3,Green); }
                                 //}//return(0);  
        }  }  }//}
//-----------------     ---------------------------------          
//*********************    *********************

if (Long)                 {     // "" 
if (NumberOfPositions("", -1, MagicBuy)<1) {//    m
   double DeltaBuy=(Ask-iOpen(Symbol(),0,0)) ;
   Comment(DeltaBuy);

   if(DeltaBuy>=n*Point)   { //long
 //  Lots=GetSizeLot(); 
    ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"ART-02",MagicBuy,0,Blue); 
    if(ticket<0){Print("   BUY #",GetLastError());return(0);}
              }} }
if (Short)                 {     // ""                
 if (NumberOfPositions("", -1, MagicSell)<1) {//    m             
  double DeltaSell=(iOpen(Symbol(),0,0)-Bid) ; 
           
 if(DeltaSell >=n_*Point)    { // short
  // Lots=GetSizeLot(); 
   ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"ART-02",MagicSell,0,Red); 
   if(ticket<0){Print("   SELL #",GetLastError());return(0);}         
              }} }   //if (NumberOfPositions...  ...
//*************************************************************************
//--- exit
   return(0);
  }
//+----------------------------------------------------------------------------+
//| ..    .                              |
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1 -  )                    |
//|    mn - MagicNumber                (-1 -  )                      |
//+----------------------------------------------------------------------------+
int NumberOfPositions(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal(), kp=0;
  if (StringLen(sy)==1 && StringGetChar(sy, 0)==48) sy=Symbol(); 
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) kp++;
          }}}}}
  return(kp);}
//-----------------------------------------------------------------------------+ 
 void TrailPositions() //  
{ int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue; 
    if (OrderType() == OP_BUY) {
      if (Bid-OrderOpenPrice() > MinProfit*Point) {
        if (OrderStopLoss() < Bid-(TrailingStop+TrailingStep-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-TrailingStop*Point,
                                                    OrderTakeProfit(), 0, Blue);
      }}}
    if (OrderType() == OP_SELL) {
      if (OrderOpenPrice()-Ask > MinProfit*Point) {
        if (OrderStopLoss() > Ask+(TrailingStop+TrailingStep-1)*Point ||
                                                         OrderStopLoss() == 0) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+TrailingStop*Point,
                                                      OrderTakeProfit(), 0, Blue);
        }}}}}
//-----------------------------------------------------------------------
/*/bool CheckExists(int Type) {
  bool Result = True;
  for(int i = 0; i < OrdersTotal(); i++)
   if(OrderSelect(i, SELECT_BY_POS))
    if(OrderType() == Type && OrderMagicNumber() == MagicBuy && OrderSymbol() == Symbol())
     if(OrderOpenTime() >= Time[0])
      Result = False;
  for(i = 0; i < OrdersHistoryTotal(); i++)
   {
    if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
     if(OrderType() == Type && OrderOpenTime() >= Time[0] 
        && OrderMagicNumber() == MagicBuy && OrderSymbol() == Symbol())
      Result = False;
    }    
      
  return(Result);    
  }
//----------------------------------------------------------------------------
 bool CheckExists_(int Type) {
  bool Result = True;
  for(int i = 0; i < OrdersTotal(); i++)
   if(OrderSelect(i, SELECT_BY_POS))
    if(OrderType() == Type && OrderMagicNumber() == MagicSell && OrderSymbol() == Symbol())
     if(OrderOpenTime() >= Time[0])
      Result = False;
  for(i = 0; i < OrdersHistoryTotal(); i++)
   {
    if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
     if(OrderType() == Type && OrderOpenTime() >= Time[0] 
        && OrderMagicNumber() == MagicSell && OrderSymbol() == Symbol())
      Result = False;
    }    
      
  return(Result);    
  } */